
local timeTot=0
local Animation = { [1] = 0, [2] = 1, [3] = 2 }
local SalvagedWaste = { [1] = "GreenGarbage", [2] = "SheetMetal", [3] = "Log", [4] = "Wood", [5] = "LibraryBookSorted", [6] = "LicensePlate", [7] = "DirtyPrisonerUniform", [8] = "FoodTrayDirty", [9] = "CrumpledPrisonerUniform", [10] = "ShopGoods", [11] = "SortedGarbage" }
local SalvagedPosX = { [1] = 0.20000, [2] = 1.10000, [3] = -1.10000, [4] = 1.10000, [5] = 0.95000, [6] = 1.15000, [7] = 1.25000, [8] = -0.95000, [9] = 1.35000, [10] = 1.15000, [11] = 0.20000 }
local SalvagedPosY = { [1] = -0.10000, [2] = -0.11000, [3] = 1.25000, [4] = 0.65000, [5] = 0.85000, [6] = 0.69000, [7] = -0.25000, [8] = 0.50000, [9] = -0.25000, [10] = 0.55000, [11] = -0.10000 }
local SalvagedItem = 1
local SpawnThis ={ [1] = "Yes", [2] = "Yes", [3] = "Yes", [4] = "Yes", [5] = "Yes", [6] = "Yes", [7] = "Yes", [8] = "Yes", [9] = "Yes", [10] = "Yes" }
local Frame = 1
local myLogo = ""
-- local ProcessingDone = true

function ItemFound(ItemToFind) -- scan for items which can be spawned. For instance: if there is no library, then no library books would be spawned by the desk.
	local nearbyItems = this.GetNearbyObjects(ItemToFind,500)
	if next(nearbyItems) then
		return true
	else
		return false
	end
	nearbyItems=nil
end
	
function MakeButtons()
	if ItemFound("GardenPot") then Object.SetProperty(this,"GreenGarbage","Yes") else Object.SetProperty(this,"GreenGarbage","No") end
	if ItemFound("WorkshopSaw") then Object.SetProperty(this,"SheetMetal","Yes") else Object.SetProperty(this,"SheetMetal","No") end
	if ItemFound("WorkshopSaw") then Object.SetProperty(this,"Log","Yes") else Object.SetProperty(this,"Log","No") end
	if ItemFound("CarpenterTable") then Object.SetProperty(this,"Wood","Yes") else Object.SetProperty(this,"Wood","No") end
	if ItemFound("LibraryBookshelf") then Object.SetProperty(this,"LibraryBookSorted","Yes") else Object.SetProperty(this,"LibraryBookSorted","No") end
	if ItemFound("WorkshopPress") then Object.SetProperty(this,"LicensePlate","Yes") else Object.SetProperty(this,"LicensePlate","No") end
	if ItemFound("LaundryBasket") then Object.SetProperty(this,"DirtyPrisonerUniform","Yes") else Object.SetProperty(this,"DirtyPrisonerUniform","No") end
	if ItemFound("Sink") then Object.SetProperty(this,"FoodTrayDirty","Yes") else Object.SetProperty(this,"FoodTrayDirty","No") end
	if ItemFound("IroningBoard") then Object.SetProperty(this,"CrumpledPrisonerUniform","Yes") else Object.SetProperty(this,"CrumpledPrisonerUniform","No") end
	if ItemFound("ShopShelf") then Object.SetProperty(this,"ShopGoods","Yes") else Object.SetProperty(this,"ShopGoods","No") end
	Interface.AddComponent( this,"toggleSpawn1", "Button", "Green Garbage: "..this.GreenGarbage.."")
	Interface.AddComponent( this,"toggleSpawn2", "Button", "Sheet Metal: "..this.SheetMetal.."")
	Interface.AddComponent( this,"toggleSpawn3", "Button", "Log: "..this.Log.."")
	Interface.AddComponent( this,"toggleSpawn4", "Button", "Wood: "..this.Wood.."")
	Interface.AddComponent( this,"toggleSpawn5", "Button", "Library Books: "..this.LibraryBookSorted.."")
	Interface.AddComponent( this,"toggleSpawn6", "Button", "License Plates: "..this.LicensePlate.."")
	Interface.AddComponent( this,"toggleSpawn7", "Button", "Prisoner Uniforms: "..this.DirtyPrisonerUniform.."")
	Interface.AddComponent( this,"toggleSpawn8", "Button", "Dirty FoodTrays: "..this.FoodTrayDirty.."")
	Interface.AddComponent( this,"toggleSpawn9", "Button", "Crumpled Uniforms: "..this.CrumpledPrisonerUniform.."")
	Interface.AddComponent( this,"toggleSpawn10", "Button", "Shop Goods: "..this.ShopGoods.."")
	Object.SetProperty(this,"RecycleAnimation","Yes")
	Interface.AddComponent( this,"toggleRecycleAnimation", "Button", "Recycle Animation: "..this.RecycleAnimation.."")
	Object.SetProperty(this,"SpawnTimer",0)
	Object.SetProperty(this,"SpawnRate",3)
	Interface.AddComponent( this,"toggleSpawnRate", "Button", "Spawn: every "..this.SpawnRate.." bags")
	Object.SetProperty(this,"Tooltip","Click the buttons to determine what the\nRecycleDesk should find in the rubbish.\n\nThe SpawnRate determines how many turns\nthere are in between each item to spawn.\nA higher number means less spawned items.\n\nGreen Garbage will always have a 10%\nspawn chance when the button is turned off.\nTurn the button on when having big gardens\nor when you need some more fertilizer.")
	SpawnThis[1]=this.GreenGarbage
	SpawnThis[2]=this.SheetMetal
	SpawnThis[3]=this.Log
	SpawnThis[4]=this.Wood
	SpawnThis[5]=this.LibraryBookSorted
	SpawnThis[6]=this.LicensePlate
	SpawnThis[7]=this.DirtyPrisonerUniform
	SpawnThis[8]=this.FoodTrayDirty
	SpawnThis[9]=this.CrumpledPrisonerUniform
	SpawnThis[10]=this.ShopGoods
end

function Create()
	local timePerUpdate=3
	MakeButtons()
	FindMyLogo()
end

function FindMyLogo()
	local Logos = this.GetNearbyObjects('RecycleAnimation',1)
	if next(Logos) then
		for thatLogo, distance in pairs (Logos) do
			if thatLogo.HomeUID==this.HomeUID then
				myLogo=thatLogo
			end
		end
	end
end

function toggleSpawn1Clicked()
	if this.GreenGarbage=="Yes" then
		Object.SetProperty(this,"GreenGarbage","No")
		DeleteLeftOvers("GreenGarbage")
	else
		Object.SetProperty(this,"GreenGarbage","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn1", "Green Garbage: "..this.GreenGarbage.."")
	SpawnThis[1]=this.GreenGarbage
end

function toggleSpawn2Clicked()
	if this.SheetMetal=="Yes" then
		Object.SetProperty(this,"SheetMetal","No")
		DeleteLeftOvers("SheetMetal")
	else
		Object.SetProperty(this,"SheetMetal","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn2", "Sheet Metal: "..this.SheetMetal.."")
	SpawnThis[2]=this.SheetMetal
end

function toggleSpawn3Clicked()
	if this.Log=="Yes" then
		Object.SetProperty(this,"Log","No")
		DeleteLeftOvers("Log")
	else
		Object.SetProperty(this,"Log","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn3", "Log: "..this.Log.."")
	SpawnThis[3]=this.Log
end

function toggleSpawn4Clicked()
	if this.Wood=="Yes" then
		Object.SetProperty(this,"Wood","No")
		DeleteLeftOvers("Wood")
	else
		Object.SetProperty(this,"Wood","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn4", "Wood: "..this.Wood.."")
	SpawnThis[4]=this.Wood
end

function toggleSpawn5Clicked()
	if this.LibraryBookSorted=="Yes" then
		Object.SetProperty(this,"LibraryBookSorted","No")
		DeleteLeftOvers("LibraryBookSorted")
	else
		Object.SetProperty(this,"LibraryBookSorted","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn5", "Library Books: "..this.LibraryBookSorted.."")
	SpawnThis[5]=this.LibraryBookSorted
end

function toggleSpawn6Clicked()
	if this.LicensePlate=="Yes" then
		Object.SetProperty(this,"LicensePlate","No")
		DeleteLeftOvers("LicensePlate")
	else
		Object.SetProperty(this,"LicensePlate","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn6", "License Plates: "..this.LicensePlate.."")
	SpawnThis[6]=this.LicensePlate
end

function toggleSpawn7Clicked()
	if this.DirtyPrisonerUniform=="Yes" then
		Object.SetProperty(this,"DirtyPrisonerUniform","No")
		DeleteLeftOvers("DirtyPrisonerUniform")
	else
		Object.SetProperty(this,"DirtyPrisonerUniform","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn7", "Prisoner Uniforms: "..this.DirtyPrisonerUniform.."")
	SpawnThis[7]=this.DirtyPrisonerUniform
end

function toggleSpawn8Clicked()
	if this.FoodTrayDirty=="Yes" then
		Object.SetProperty(this,"FoodTrayDirty","No")
		DeleteLeftOvers("FoodTrayDirty")
	else
		Object.SetProperty(this,"FoodTrayDirty","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn8", "Dirty FoodTrays: "..this.FoodTrayDirty.."")
	SpawnThis[8]=this.FoodTrayDirty
end

function toggleSpawn9Clicked()
	if this.CrumpledPrisonerUniform=="Yes" then
		Object.SetProperty(this,"CrumpledPrisonerUniform","No")
		DeleteLeftOvers("CrumpledPrisonerUniform")
	else
		Object.SetProperty(this,"CrumpledPrisonerUniform","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn9", "Crumpled Uniforms: "..this.CrumpledPrisonerUniform.."")
	SpawnThis[9]=this.CrumpledPrisonerUniform
end

function toggleSpawn10Clicked()
	if this.ShopGoods=="Yes" then
		Object.SetProperty(this,"ShopGoods","No")
		DeleteLeftOvers("ShopGoods")
	else
		Object.SetProperty(this,"ShopGoods","Yes")
	end
	this.SetInterfaceCaption("toggleSpawn10", "Shop Goods: "..this.ShopGoods.."")
	SpawnThis[10]=this.ShopGoods
end

function toggleRecycleAnimationClicked()
	if this.RecycleAnimation=="Yes" then
		Object.SetProperty(this,"RecycleAnimation","No")
		if myLogo~=nil then myLogo.Delete() end
	else
		Object.SetProperty(this,"RecycleAnimation","Yes")
		myLogo = Object.Spawn( "RecycleAnimation", this.Pos.x,this.Pos.y)
		Object.SetProperty(myLogo,"HomeUID",this.HomeUID)
	end
	this.SetInterfaceCaption("toggleRecycleAnimation", "Recycle Animation: "..this.RecycleAnimation.."")
end

function toggleSpawnRateClicked()
	Object.SetProperty(this,"SpawnRate",this.SpawnRate+2)
	if this.SpawnRate>9 then
		Object.SetProperty(this,"SpawnRate",1)
	end
	this.SetInterfaceCaption("toggleSpawnRate", "Spawn: every "..this.SpawnRate.." bags")
end

function DeleteLeftOvers(ItemToDelete)
	local LeftOverItems = this.GetNearbyObjects(ItemToDelete,2)
	if next(LeftOverItems) then
		for thatItem, distance in pairs (LeftOverItems) do
			thatItem.Delete()
		end
	end
	local LeftOverStacks = this.GetNearbyObjects("Stack",2)
	if next(LeftOverStacks) then
		for thatStack, distance in pairs (LeftOverStacks) do
			if thatStack.Contents==ItemToDelete then
				thatStack.Delete()
			end
		end
	end
end

function UnloadGarbage()
	local LeftOverItems = this.GetNearbyObjects("UnsortedGarbage",2)
	if next(LeftOverItems) then
		for thatItem, distance in pairs (LeftOverItems) do
			thatItem.CarrierId.i = -1
			thatItem.CarrierId.u = -1
			this.Slot0.i = -1
			this.Slot0.u = -1
			thatItem.Loaded = false
			thatItem.Locked = false
			Object.ApplyVelocity(thatItem, 0.2, -0.1)
		end
	end
	local LeftOverItems = this.GetNearbyObjects("SortedGarbage",2)
	if next(LeftOverItems) then
		for thatItem, distance in pairs (LeftOverItems) do
			thatItem.CarrierId.i = -1
			thatItem.CarrierId.u = -1
			this.Slot2.i = -1
			this.Slot2.u = -1
			thatItem.Loaded = false
			thatItem.Locked = false
			Object.ApplyVelocity(thatItem, 0.2, -0.1)
		end
	end
	local LeftOverStacks = this.GetNearbyObjects("Stack",2)
	if next(LeftOverStacks) then
		for thatStack, distance in pairs (LeftOverStacks) do
			if thatStack.CarrierId.u==this.Id.u then
				thatStack.CarrierId.i = -1
				thatStack.CarrierId.u = -1
				this.Slot0.i = -1
				this.Slot0.u = -1
				this.Slot2.i = -1
				this.Slot2.u = -1
				thatStack.Loaded = false
				thatStack.Locked = false
				Object.ApplyVelocity(thatStack, 0.2, -0.1)
			end
		end
	end
end

function Update( timePassed )
	if timePerUpdate==nil then
		if this.SpawnTimer == nil then return end
		if this.SpawnRate==nil then
			MakeButtons()
		else
			Interface.AddComponent( this,"toggleSpawn1", "Button", "Green Garbage: "..this.GreenGarbage.."")
			Interface.AddComponent( this,"toggleSpawn2", "Button", "Sheet Metal: "..this.SheetMetal.."")
			Interface.AddComponent( this,"toggleSpawn3", "Button", "Log: "..this.Log.."")
			Interface.AddComponent( this,"toggleSpawn4", "Button", "Wood: "..this.Wood.."")
			Interface.AddComponent( this,"toggleSpawn5", "Button", "Library Books: "..this.LibraryBookSorted.."")
			Interface.AddComponent( this,"toggleSpawn6", "Button", "License Plates: "..this.LicensePlate.."")
			Interface.AddComponent( this,"toggleSpawn7", "Button", "Prisoner Uniforms: "..this.DirtyPrisonerUniform.."")
			Interface.AddComponent( this,"toggleSpawn8", "Button", "Dirty FoodTrays: "..this.FoodTrayDirty.."")
			Interface.AddComponent( this,"toggleSpawn9", "Button", "Crumpled Uniforms: "..this.CrumpledPrisonerUniform.."")
			Interface.AddComponent( this,"toggleSpawn10", "Button", "Shop Goods: "..this.ShopGoods.."")
			Interface.AddComponent( this,"toggleRecycleAnimation", "Button", "Recycle Animation: "..this.RecycleAnimation.."")
			Interface.AddComponent( this,"toggleSpawnRate", "Button", "Spawn: every "..this.SpawnRate.." bags")
			SpawnThis[1]=this.GreenGarbage
			SpawnThis[2]=this.SheetMetal
			SpawnThis[3]=this.Log
			SpawnThis[4]=this.Wood
			SpawnThis[5]=this.LibraryBookSorted
			SpawnThis[6]=this.LicensePlate
			SpawnThis[7]=this.DirtyPrisonerUniform
			SpawnThis[8]=this.FoodTrayDirty
			SpawnThis[9]=this.CrumpledPrisonerUniform
			SpawnThis[10]=this.ShopGoods
		end
		timePerUpdate=3
		FindMyLogo()
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
		if this.Slot0.i~=nil and this.Slot0.i>0 and this.Slot2.i~=nil and this.Slot2.i>0 then
		--	ProcessingDone=false
			Object.SetProperty(this,"SpawnTimer",this.SpawnTimer+1)
			if this.SpawnTimer>=this.SpawnRate then
				Object.SetProperty(this,"SpawnTimer",0)
				local ItemSpawned=false
				local myTimer=1
				while ItemSpawned==false do
					SalvagedItem=math.random(1,10)
					if SpawnThis[SalvagedItem]=="Yes" then
						if SalvagedItem==5 or SalvagedItem==7 or SalvagedItem==9 or SalvagedItem==10 then
							local name = Object.Spawn(SalvagedWaste[SalvagedItem], this.Pos.x+0.250000,this.Pos.y+0.250000)
							local velX = SalvagedPosX[SalvagedItem]
							local velY = SalvagedPosY[SalvagedItem]
							Object.ApplyVelocity(name, velX, velY)
						else
							local name = Object.Spawn(SalvagedWaste[SalvagedItem], this.Pos.x+SalvagedPosX[SalvagedItem],this.Pos.y+SalvagedPosY[SalvagedItem])
						end
						ItemSpawned=true
					end
					myTimer=myTimer+1
					if myTimer>=10 and ItemSpawned==false then 	-- if it fails to salvage something random within 10 tries, then just spawn sorted garbage instead of keep on trying. This will prevent a loop if all buttons would be set to "No"
						local name = Object.Spawn(SalvagedWaste[11], this.Pos.x+SalvagedPosX[11],this.Pos.y+SalvagedPosY[11])
						local velX = SalvagedPosX[11]
						local velY = SalvagedPosY[11]
						Object.ApplyVelocity(name, velX, velY);
						ItemSpawned=true
					end																		 						
				end
			end
		end
		if tonumber(this.JobId) == -1 and tonumber(this.Slot2.i) > -1 then	-- unload leftover Garbage
			UnloadGarbage()
		end
		
		if this.RecycleAnimation=="Yes" then
			if this.Slot0.i~=nil and this.Slot0.i>0 and this.Slot1.i~=nil and this.Slot1.i>0 then
				myLogo.SubType = Animation[Frame]
				Frame = Frame + 1
				if Frame > #Animation then
					Frame = 1
				end
			else			
				myLogo.SubType = 0
			end
		end
		
	end
end
